function GR=BGramComputation(A,N,nmin,nmax,eta,sigma)

%% (c) 2004 Marco Cuturi , marco.cuturi@ensmp.fr
%% Distributed under GPL licence


% This function computes a GramMatrix of Bhattacharyya kernel evaluations
% on images contained in A, where:
% A : a matrix of images
% N : amount of points to take into account in the matrix
% nmin , nmax : minimal and maximal sample size (amount of pixels) taken in
% each image
% eta : regularization parameter
% sigma : Gaussian kernel width, 0 value means linear kernel.


taille=size(A);
n=taille(1,1);

if (N>n) 
    N=n;
end
B=matsample(A(1:N,:),nmin,nmax);
GR=zeros(N,N);
norm=zeros(1,N);

%%%%%%%%% Remove the comment mark below if you want to add 
%%%%%%%%% some noise to create better separated points and 
%%%%%%%%% you have access to statistics toolbox.
%%%%%%%%% This is noising is in a way redundant with the
%%%%%%%%% the addition of a small diagonal component
%%%%%%%%% to the original Gram matrix before doing
%%%%%%%%% eigendecomposition.
% B(:,3:end)=B(:,3:end)+normrnd(0,0.3,N,nmax)+i*normrnd(0,0.3,N,nmax);
fix(clock)

for j=1:N
    GR(j,j)=1;
end;
for j=1:N
    j
    for i=j+1:N
        GR(i,j)=exp(-BKernel(B(i,:),B(j,:),eta,sigma));
        GR(j,i)=GR(i,j);
    end;
end;

fix(clock)